Description

This is a guide on virtualizing an ARM based operating system, in this case Raspbian for the Raspberry Pi 3, on an x86_64 Arch
Linux system.

Prepare the environment

o Make sure the system is up to date:
sudo pacman —-Syu
¢ |nstall a few dependencies:

sudo pacman -S git base-devel wget

Prepare Disk Image

e Create the guest drive:
dd if=/dev/zero of=~/raspi.img bs=1M count=16384
e Format the guest drive:

fdisk ~/raspi.img

o Basic format:
e Download the latest raspberry pi OS image:

mkdir ~/raspios && cd ~/raspios
wget https://downloads.raspberrypi.org/raspios_lite_armhf/images/raspios_lite_armhf-2022-01-28
/2022-01-28-raspios-bullseye-armhf-lite.zip
unzip 2022-01-28-raspios-bullseye-armhf-lite.zip

e Populate the guest drive:

mkdir ~/src_boot && mkdir ~/src_root && mkdir ~/dst_boot && mkdir dst_root

sudo
sudo
sudo
sudo
sudo
sudo
sudo
sudo
sudo
sudo
sudo
sudo

losetup -f —--show ~/raspi.img

partx —-a /dev/loopO

mkfs.vfat /dev/loopOpl

mkfs.ext4d /dev/loopOp2

mount /dev/loopOpl ~/dst_boot

mount /dev/loopOp2 ~/dst_root

losetup —-f -o 4194304 --show ~/raspbian/2022-01-28-raspios-bullseye-armhf-lite.img
mount /dev/loopl ~/src_boot

losetup -f -0 272629760 --show ~/raspios/2022-01-28-raspios-bullseye-armhf-lite.img
mount /dev/loop2 ~/src_root

cp —-r ~/src_boot/*.* ~/dst_boot/

cp -r ~/src_root/* ~/dst_root/

e Edit the guest drive fstab:

sudo

nano ~/root/etc/fstab

o And change the following:

/dev/sdal /boot vfat defaults 0
/dev/sda2 / ext4d defaults,noatime 0 1

e Unmount the guest drive:

sudo
sudo
sudo
sudo
sudo
sudo
sudo

umount ~/src_boot
umount ~/src_root
umount ~/dst_boot
umount ~/dst_root
losetup -d /dev/loop2
losetup -d /dev/loopl
losetup -d /dev/loopl

Install Qemu

e |nstall gemu and the extra architectures:

pacman -S git gemu gemu-arch-extra wget

* Download prebuilt kernels:

mkdir ~/git && cd ~/git
git clone https://github.com/dhruvvyas90/gemu-rpi-kernel.git

Run Qemu

* Run the newly built kernel with the latest raspbian:
gemu-system—-aarch64 -kernel ~/git/gemu-rpi-kernel/kernel-gemu-5.10.63-bullseye —-cpu armll76 -M
raspi3b -m 1024 -dtb ~/git/gemu-rpi-kernel/native-emulation/dtbs/bcm2711l-rpi-4-b.dtb -serial
stdio —append "root=/dev/sda2 rootfstype=ext4 rw" -drive format=raw,file=/media/winshare/raspi

.img -net nic,macaddr=20:20:20:67:89:0a —-net user,hostfwd=tcp::5022-:22 -no-reboot

e Log in as the user pi with the password raspberry

e Configure the pi to your use case:
sudo raspi-config

o Go to Interfacing and enable SSH.
o Change Localization.

Compiling Latest kernel
Install ARM toolchain:

e Clone the toolchain repo (using --depth 1 will decrease the overall download size by 400MB):

mkdir ~/git && cd ~/git
git clone —--depth 1 https://github.com/raspberrypi/tools.git

¢ Add the tools to your path:

echo 'export PATH=S$PATH:~/git/tools/arm-bcm2708/gcc-linaro-arm-linux-gnueabihf-raspbian/bin' >
> ~/.bash_profile

e Source the .bash_profile:

source ~/.bash_profile

Compile Kernel

® Download the gemu-rpi-kernel repo:

cd ~/git
git clone https://github.com/dhruvvyas90/gemu-rpi-kernel.git

¢ Clone the specific kernel version to use:

cd gemu-rpi-kernel/tools
git clone -b rpi-5.10.y —--depth 1 https://github.com/raspberrypi/linux.git

* Modify the kernel compile script to use Arch commands:

sed -i.bak -e's/sudo\ apt-get\ update/sudo\ pacman\ -Syu/g' -e's/sudo\ apt-get\ install\ git\
libncurses5-dev\ gcc-arm-linux—-gnueabihf/sudo\ pacman\ -S\ git/g' build-kernel-gemu

o Edit the build-kernel-qemu script:
vi build-kernel-gemu
o And comment out all COMMIT versions except for the desired commit, and also comment out the exit command before the

make commands:

#COMMIT=6820d0cbec64cfee481b961833feffec888011le
#COMMIT=raspberrypi-kernel 1.20171029-1
#COMMIT=""

COMMIT=rpi-5.10.y

#exit

Run the build script:

./build-kernel-gemu

Resources

https://azeria-labs.com/emulate-raspberry-pi-with-gemu/
http://graznik.de/posts/emulate-ras rry-pi-with-qgemu/
http://downloads.raspberrypi.org/raspbian/images/raspbian-2018-03-14/
https://github.com/raspberrypi/linux/releases
https://github.com/dhruvvyas90/gemu-rpi-kernel

History

#1 - 04/08/2018 12:14 AM - Daniel Curtis
- Subject changed from Run Raspbian on x86_64 Arch Linux to Virtualize Raspbian on x86_64 Arch Linux

- Description updated

#2 - 04/08/2018 02:24 PM - Daniel Curtis

- Description updated

- Category set to Development

- Status changed from New to In Progress

- Estimated time set to 2.50 h

#3 - 04/08/2018 02:26 PM - Daniel Curtis

- Description updated

- % Done changed from 0 to 100

#4 - 04/11/2018 10:36 AM - Daniel Curtis

- Status changed from In Progress to Resolved

#5 - 06/10/2019 02:33 PM - Daniel Curtis

- Status changed from Resolved to Closed

#6 - 01/30/2022 02:17 PM - Daniel Curtis

- Description updated

- Subject changed from Virtualize Raspbian on x86_64 Arch Linux to Emulate Raspberry Pi OS on x86_64 Arch Linux

#7 - 01/30/2022 02:27 PM - Daniel Curtis

- Description updated

#8 - 01/30/2022 02:49 PM - Daniel Curtis

- Description updated
